/*
 *
 * Author: Allan <qimingos_lsk@163.com>, (C) 2005-2007
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 */
#include "../include/ShowLyric.h"
#include "../include/EditLyricDlg.h"
#include "../include/ShowLyricDlg.h"

#define EDIT_LYRIC_GLADE_FILE "/usr/share/ShowLyric/EditLyricDlg.glade"

#define this  theApp.m_LyricWnd
void LyricWndInit()
{
	this.ShowLyric = ShowLyric;
	this.ParseLyric = ParseLyric;
	this.SmartShowWnd = SmartShowWnd;
	this.ClearLyric = ClearLyric;
	this.RefreshLyricSetting = RefreshLyricSetting;
	this.m_TimerId = 0;
	this._m_current = NULL;
	this.m_ListCurrLyric = NULL;
	this.m_bScrollMouseChange = FALSE;
	this.m_bLyricChanged = FALSE;
	this.m_bLyricChanging = FALSE;

	GtkWidget* pShowLyric = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
	gtk_window_set_keep_above(GTK_WINDOW(pShowLyric), TRUE);
	glade_xml_signal_connect_data(theApp.m_xml,
			"on_ShowLyric_window_state_event",
			G_CALLBACK(on_ShowLyric_window_state_event), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_ShowLyric_delete_event",
			G_CALLBACK(on_ShowLyric_delete_event), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml,
			"on_ShowLyric_button_press_event",
			G_CALLBACK(on_ShowLyric_button_press_event), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml,
			"on_ShowLyric_scroll_event",
			G_CALLBACK(on_ShowLyric_scroll_event), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml,
			"on_ShowLyric_motion_notify_event",
			G_CALLBACK(on_ShowLyric_motion_notify_event), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuEditLyric_activate",
			G_CALLBACK(on_MenuEditLyric_activate), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuReDownLoad_activate",
			G_CALLBACK(on_MenuReDownLoad_activate), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuConfig_activate",
			G_CALLBACK(on_MenuConfig_activate), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuAbout_activate",
			G_CALLBACK(on_MenuAbout_activate), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuUpTime_activate",
			G_CALLBACK(on_MenuUpTime_activate), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuDownTime_activate",
			G_CALLBACK(on_MenuDownTime_activate), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuMouseScroll_toggled",
				G_CALLBACK(on_MenuMouseScroll_toggled), pShowLyric);
	glade_xml_signal_connect_data(theApp.m_xml, "on_MenuShowBroad_toggled",
				G_CALLBACK(on_MenuShowBroad_toggled), pShowLyric);
	

	this.m_EditLyricDlg.m_pEditLyricXML = glade_xml_new(EDIT_LYRIC_GLADE_FILE, NULL, NULL);
	EditLyricDlgInit();
	SmartShowWnd(FALSE);
}

// 将字符串“00:12.123”转化为数字
int _GetTime(gchar* lpszTime)
{
	int iMS = 0, iSec = 0, iMinute = 0;
	gchar* lpszTmp= NULL;
	int iBegin = StrLeftFind(lpszTime, 0, '.');
	if (iBegin >= 0)
	{
		lpszTmp = lpszTime + iBegin;
		*lpszTmp = 0;
		lpszTmp++;
		iMS = atoi(lpszTmp);
	}
	iBegin = StrLeftFind(lpszTime, 0, ':');
	if (iBegin >= 0)
	{
		lpszTmp = lpszTime + iBegin;
		*lpszTmp = 0;
		lpszTmp++;
		iSec = atoi(lpszTmp);
	}
	iMinute = atoi(lpszTime);
	return (iMinute * 60 + iSec) * 1000 + iMS;
}

void _ClearList()
{
	g_assert(!this.m_bLyricChanging);
	// TODO: 保存修改后的歌词
	GList *list= this.m_ListCurrLyric;
	GList* OldList = list;
	this.m_ListCurrLyric = NULL;
	this._m_current = NULL;
	if (OldList)
	{
		gtk_timeout_remove(this.m_TimerId);
		usleep(500);
	}
	GtkWidget* pVbox = glade_xml_get_widget(theApp.m_xml, "vboxLyrics");
	while (list)
	{
		LyricItem *item = (LyricItem *) list->data;

		g_free(item->lpszValue);
		gtk_widget_destroy(item->pLabel);
		g_free(item);
		list = g_list_next(list);
	}
	g_list_free(OldList);
	gtk_widget_hide(GTK_WIDGET(pVbox));
}

// 将一个时间点的歌词加入到链表里面去
void _ParseLine(int iTime, gchar* lpszValue)
{
	GList* list = g_list_first(this.m_ListCurrLyric);
	LyricItem *pNewItem = (LyricItem *)g_malloc0(sizeof(LyricItem));
	pNewItem->iTime = iTime;
	pNewItem->lpszValue = (gchar *)g_malloc0(strlen(lpszValue) + 1);
	strcpy(pNewItem->lpszValue, lpszValue);
	gchar* pWork = pNewItem->lpszValue;
	while (*pWork != 0)
	{
		if (*pWork == '\r' || *pWork == '\n')
			*pWork = '\0';
		pWork++;
	}
	while (list)
	{
		LyricItem* lpItem = list->data;
		if (lpItem->iTime > iTime)
		{
			this.m_ListCurrLyric = g_list_insert_before(this.m_ListCurrLyric,
					list, pNewItem);
			return;
		}
		list = g_list_next(list);
	}
	this.m_ListCurrLyric = g_list_append(this.m_ListCurrLyric, pNewItem);
}

// 解析歌词
gboolean ParseLyric(gchar* lpszLyricFileName)
{
	_ClearList();
	FILE * pLyricFile = fopen(lpszLyricFileName, "r");
	if (!pLyricFile)
	{
		LyricLog("加载歌词文件%s失败", lpszLyricFileName);
		theApp.m_LyricWnd.SmartShowWnd(FALSE);
		return FALSE;
	}
	gchar szBuf[512] =
	{ 0 };

	fgets(szBuf, 512, pLyricFile);
	fseek(pLyricFile, 0, SEEK_END);
	int iLen = ftell(pLyricFile);
	fseek(pLyricFile, 0, SEEK_SET);
	gchar * lpszLine = (gchar *)g_malloc(iLen);
	while (fgets(lpszLine, iLen, pLyricFile) != NULL)
	{
		int iEnd = StrLeftFind(lpszLine, 0, ']');
		if (iEnd > 0)
		{
			gchar* pValue = lpszLine + iEnd;
			*pValue = 0;
			pValue++;
			gchar* lpszTimes = lpszLine;
			int iBegin = StrLeftFind(lpszTimes, 0, '[');
			while (iBegin >= 0)
			{
				gchar* lpszTime = lpszTimes + iBegin;
				*lpszTime = 0;
				lpszTime++;
				if (lpszTime[strlen(lpszTime) - 1] == ']')
					lpszTime[strlen(lpszTime) - 1] = 0;
				// 转换时间pTime为iTime
				int iTime = _GetTime(lpszTime);
				_ParseLine(iTime, pValue);
				iBegin = StrLeftFind(lpszTimes, 0, '[');
			}
		}
	}

	fclose(pLyricFile);
	pLyricFile = NULL;
	g_free(lpszLine);
	lpszLine = NULL;

	if (g_list_length(this.m_ListCurrLyric) > 0)
	{
		theApp.SetAppState(AS_ShowingLyric);
		ShowLyric();
	}
	return TRUE;
}

void ClearLyric()
{
	LyricDebug("ClearLyric------------------------------------");

	this.m_bLyricChanging = FALSE;
	this.m_bLyricChanged = FALSE;
	_ClearList();
}

void SmartShowWnd(gboolean bShow)
{
	GtkWidget * pEditLyricDlg = glade_xml_get_widget(
	this.m_EditLyricDlg.m_pEditLyricXML,
	"EditLyricDlg");
	GtkWidget *pLyricWnd = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
	if (this.m_EditLyricDlg.m_bEditing)
	{
		gtk_widget_show(pEditLyricDlg);
		gtk_widget_hide(pLyricWnd);
		return;
	}
	else
	{
		gtk_widget_hide(pEditLyricDlg);
	}

	if (!theApp.m_configs.bSmartShowWin)
		return;
	if (bShow)
	{
		gtk_window_set_keep_above(GTK_WINDOW(pLyricWnd), TRUE);
		gtk_window_move(GTK_WINDOW(pLyricWnd), theApp.m_configs.pos.iX,
				theApp.m_configs.pos.iY);
		gtk_widget_show(pLyricWnd);
	}
	else
	{
		gtk_widget_hide(pLyricWnd);
	}
}

gboolean ScrollLyric(gpointer data)
{
	if (this.m_bLyricChanging) return TRUE;
	GtkWidget *pLyricWnd = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
	GtkWidget* pVbox = glade_xml_get_widget(theApp.m_xml, "vboxLyrics");
	GtkWidget* pLayout = glade_xml_get_widget(theApp.m_xml, "layoutLyrics");
	int iTime = theApp.m_player.GetCurrTime();
	GList *list= this.m_ListCurrLyric;

	GList *previous= this._m_current;
	GList *current= this._m_current;
	//int the_y = GTK_WIDGET(pLyricWnd)->allocation.height / 2;

	if (!current && list)
	{
		current = list;
	}
	else if (!current && !list)
	{
		return TRUE;
	}
	int iCCC = 0;
	// 找到当前项
	// 往后找，直到使当前项的时间大于给出的时间为止
	while (TRUE)
	{
		if (iCCC++ > 1000)
		{
			break;
		}
		if (((LyricItem *) current->data)->iTime > iTime)
		{
			break;
		}
		else
		{
			if (current->next) // 如果不是最后一个
				current = current->next;
			else
			{
				break;
			}
		}
	}

	if (!current || !current->data)
	{
		LyricLog("current is empty!");
		return TRUE;
	}
	// 如果当前项已经变更则更新
	if (previous != current)
		this._m_current = current;

	// set colors
	int threshold = 300;
	GList *p= NULL;

	iCCC = 0;
	for (p = list; p; p = p->next)
	{
		if (iCCC++ > 1000)
		{
			break;
		}
		gint p_time = ((LyricItem *) (p->data))->iTime;
		gint pn_time = p->next ? ((LyricItem *) (p->next->data))->iTime : 0;

		if (iTime < p_time - threshold || (p->next && pn_time + threshold
				< iTime))
		{
			if (((LyricItem *) p->data)->process_color)
			{
				((LyricItem *) p->data)->process_color = FALSE;
				gtk_widget_modify_fg(((LyricItem *) p->data)->pLabel,
						GTK_STATE_NORMAL, &theApp.m_configs.colors.normal);
			}
		}
		else if (iTime < p_time + threshold)
		{
			int delta = (iTime - p_time + threshold) / 2;
			GdkColor color;

			color_between(&theApp.m_configs.colors.normal,
					&theApp.m_configs.colors.current, (gdouble) delta
							/ threshold, &color);
			gtk_widget_modify_fg(((LyricItem *) p->data)->pLabel, GTK_STATE_NORMAL,
					&color);
			((LyricItem *) p->data)->process_color = TRUE;
		}
		else if (p->next && iTime < pn_time - threshold)
		{
			gtk_widget_modify_fg(((LyricItem *) p->data)->pLabel, GTK_STATE_NORMAL,
					&theApp.m_configs.colors.current);
			((LyricItem *) p->data)->process_color = TRUE;
		}
		else if (p->next && iTime < pn_time + threshold)
		{
			int delta = (pn_time + threshold - iTime) / 2;
			GdkColor color;

			color_between(&theApp.m_configs.colors.normal,
					&theApp.m_configs.colors.current, (gdouble) delta
							/ threshold, &color);
			gtk_widget_modify_fg(((LyricItem *) p->data)->pLabel, GTK_STATE_NORMAL,
					&color);
			((LyricItem *) p->data)->process_color = TRUE;
		}
	}

	// 如果已经是最后一项了，直接返回
	if (!current->next || !current->data)
	{
		return TRUE;
	}
	// 保持当前行在最中间
	LyricItem *pCurrentItem = (LyricItem *) current->data;
	int iNewY = pVbox->allocation.y - pCurrentItem->pLabel->allocation.y
			+ pLyricWnd->allocation.height / 2;
	if (current->next)
	{
		LyricItem *pNextItem = (LyricItem *) current->next->data;
		double f = ((double)iTime - pCurrentItem->iTime) / (pNextItem->iTime
				- pCurrentItem->iTime);
		int iAdd = (GTK_WIDGET(pNextItem->pLabel)->allocation.y - GTK_WIDGET(pCurrentItem->pLabel)->allocation.y) * f;
		iNewY -= iAdd;
	}
	if (IsSmaller(&iNewY) || iNewY == 0)
	{
		gtk_layout_move(GTK_LAYOUT(pLayout), pVbox, 18, iNewY);
		//LyricDebug("iNewY=%d", iNewY);
	}
	gtk_window_get_position(GTK_WINDOW(pLyricWnd), &theApp.m_configs.pos.iX,
			&theApp.m_configs.pos.iY);
	return TRUE;
}

inline gint number_between(gint from, gint to, gdouble rate)
{
	return from + rate * (to - from);
}

void color_between(GdkColor * from, GdkColor * to, gdouble rate,
		GdkColor * result)
{
	if (!from || !to || !result)
		return;
	result->pixel = number_between(from->pixel, to->pixel, rate);
	result->red = number_between(from->red, to->red, rate);
	result->green = number_between(from->green, to->green, rate);
	result->blue = number_between(from->blue, to->blue, rate);
}

inline gboolean IsSmaller(int *piNew)
{
	static int iOldY;
	static int iBuffer; // 如果跳跃太大，多余的跳跃将缓存到该变量中，在后面的移动中慢慢释放出来，以防止跳跃太大
	static int iRate; // 释放缓存的速度

	if (*piNew == 50000)
	{
		iOldY = *piNew;
		iBuffer = 0;
		iRate = 0;
		return TRUE;
	}
	// 如果是后退则直接后退
	if (*piNew > iOldY + 50)
	{
		iOldY = *piNew;
		iBuffer = 0;
		iRate = 0;
		return TRUE;
	}
	// 如果是前进， 则做延缓处理
	if (*piNew < iOldY || (*piNew == iOldY && iBuffer > 0))
	{
		int iTmp = iOldY - *piNew, iFlag = iRate + 1;

		if (iTmp > iFlag && iTmp < 20)
		{
			iBuffer += iOldY - *piNew - iFlag;
			if (iBuffer <= 0)
				iRate = 0;
			else if (iBuffer <= 10)
				iRate = 1;
			else if (iBuffer <= 20)
				iRate = 2;
			else if (iBuffer <= 30)
				iRate = 3;
			else if (iBuffer <= 40)
				iRate = 4;
			else if (iBuffer <= 50)
				iRate = 5;
			else if (iBuffer <= 60)
				iRate = 6;
			else if (iBuffer > 60)
				iRate = 10;
			*piNew = iOldY - iFlag;
		}
		else
		{
			if (iBuffer > 0)
			{
				int iAdd = iRate < iBuffer ? iRate : iBuffer;

				*piNew += iAdd;
				iBuffer -= iAdd;
				if (iBuffer <= 0)
					iRate = 0;
				else if (iBuffer <= 10)
					iRate = 1;
				else if (iBuffer <= 20)
					iRate = 2;
				else if (iBuffer <= 30)
					iRate = 3;
				else if (iBuffer <= 40)
					iRate = 4;
				else if (iBuffer <= 50)
					iRate = 5;
				else if (iBuffer <= 60)
					iRate = 6;
				else if (iBuffer > 60)
					iRate = 10;
				if (iOldY - *piNew < 0)
				{
					iBuffer = iOldY - *piNew;
					*piNew = iOldY;
				}
			}
		}
		// LyricDebug("iY=%d, iBuffer=%d, iRate=%d", iOldY - *piNew, iBuffer, iRate);

		iOldY = *piNew;
		return TRUE;
	}
	return FALSE;
}

void ShowLyric()
{
	GtkWidget *pLyricWnd = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
	GtkWidget* pVbox = glade_xml_get_widget(theApp.m_xml, "vboxLyrics");
	gint iMaxWidth = 0;
	// 显示歌词
	PangoFontDescription *font_desc =
		pango_font_description_from_string(theApp.m_configs.szLyricFontName);
	GList* list = g_list_first(this.m_ListCurrLyric);
	while (list)
	{
		LyricItem* lpItem = list->data;
		if (lpItem)
		{
			lpItem->pLabel = (GtkWidget*)gtk_label_new(lpItem->lpszValue);
			gtk_label_set_single_line_mode(GTK_LABEL(lpItem->pLabel), TRUE);
			gtk_widget_modify_fg(GTK_WIDGET(lpItem->pLabel), GTK_STATE_NORMAL,
					&theApp.m_configs.colors.normal);
			gtk_widget_modify_font(GTK_WIDGET(lpItem->pLabel), font_desc);
			//			gtk_widget_modify_bg(GTK_WIDGET(lpItem->pLabel), GTK_STATE_NORMAL,
			//					&theApp.m_configs.colors.background);
			gtk_widget_show(GTK_WIDGET(lpItem->pLabel));
			gtk_box_pack_start(GTK_BOX(pVbox), GTK_WIDGET(lpItem->pLabel),
					FALSE, FALSE, 0);

			gint iWidth  = 0;
			PangoLayout *layout = NULL;
			layout = gtk_widget_create_pango_layout(GTK_WIDGET(lpItem->pLabel),
					lpItem->lpszValue);
			if(layout){
			    pango_layout_get_pixel_size(layout, &iWidth, NULL);
			    g_object_unref(layout);
			}
			if (iWidth > iMaxWidth)
				iMaxWidth = iWidth;
		}
		list = g_list_next(list);
	}

	gint iWndHeight = 0, iTemp = 0;
	gtk_window_get_size(GTK_WINDOW(pLyricWnd), &iTemp, &iWndHeight);
	gtk_window_resize(GTK_WINDOW(pLyricWnd), iMaxWidth + 40, iWndHeight);

	gtk_widget_show(GTK_WIDGET(pVbox));
	gtk_window_move(GTK_WINDOW(pLyricWnd), theApp.m_configs.pos.iX,
			theApp.m_configs.pos.iY);
	gtk_widget_show(pLyricWnd);
	SmartShowWnd(TRUE);
	this.m_TimerId = gtk_timeout_add(100, ScrollLyric, &this.m_ListCurrLyric);
}

// 刷新并生效配置
void RefreshLyricSetting()
{
	GtkWidget *pLyricWnd = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
	gtk_window_set_opacity(GTK_WINDOW(pLyricWnd), 1 - theApp.m_configs.iOpacity
			/ 100.0);
	gtk_window_set_decorated(GTK_WINDOW(pLyricWnd), theApp.m_configs.bShowBroad);
	GList* list = g_list_first(this.m_ListCurrLyric);
	gint iMaxWidth = 0;
	PangoFontDescription *font_desc =
		pango_font_description_from_string(theApp.m_configs.szLyricFontName);
	while (list)
	{
		LyricItem* lpItem = list->data;
		if (lpItem && lpItem->pLabel)
		{
			gtk_widget_modify_fg(GTK_WIDGET(lpItem->pLabel), GTK_STATE_NORMAL,
					&theApp.m_configs.colors.normal);
			gtk_widget_modify_font(GTK_WIDGET(lpItem->pLabel), font_desc);

			gint iWidth  = 0;
			PangoLayout *layout = NULL;
			layout = gtk_widget_create_pango_layout(GTK_WIDGET(lpItem->pLabel),
					lpItem->lpszValue);
			if(layout){
			    pango_layout_get_pixel_size(layout, &iWidth, NULL);
			    g_object_unref(layout);
			}
			if (iWidth > iMaxWidth)
				iMaxWidth = iWidth;
		}
		list = g_list_next(list);
	}

	gint iWndHeight = 0, iTemp = 0;
	gtk_window_get_size(GTK_WINDOW(pLyricWnd), &iTemp, &iWndHeight);
	gtk_window_resize(GTK_WINDOW(pLyricWnd), iMaxWidth + 40, iWndHeight);
	gtk_widget_modify_fg(GTK_WIDGET(pLyricWnd), GTK_STATE_NORMAL,
			&theApp.m_configs.colors.background);
}

void on_MenuAbout_activate(GtkWidget* wideget, gpointer user_data)
{
	theApp.About(GTK_WINDOW(user_data));
}

void on_MenuEditLyric_activate(GtkWidget* wideget, gpointer user_data)
{
	this.m_EditLyricDlg.EditLyric();
}

void on_MenuReDownLoad_activate(GtkWidget* wideget, gpointer user_data)
{
	SongInfo info;
	if (theApp.m_player.GetSongInfo(&info))
	{
		gchar szLrcFile[MAX_PATH] =
		{ 0 };
		sprintf(szLrcFile, "%s/%s/%s.lyric", theApp.m_configs.szLyricPath,
				info.szArtist, info.szTitle);
		strcpy(info.szLyricFileName, szLrcFile);
		theApp.SearchLyric(info, FALSE);
	}
}

void ChangeLyricTime(int iAdd)
{
	GList *list= this.m_ListCurrLyric;
	if (!list)return;
	this.m_bLyricChanging = TRUE;
	while (list)
	{
		LyricItem *item = (LyricItem *) list->data;
		item->iTime += iAdd;
		list = g_list_next(list);
	}
	this.m_bLyricChanging = FALSE;
	this.m_bLyricChanged = TRUE;
}

void on_MenuUpTime_activate(GtkWidget* wideget, gpointer user_data)
{
	ChangeLyricTime(500);
}

void on_MenuDownTime_activate(GtkWidget* wideget, gpointer user_data)
{
	ChangeLyricTime(-500);
}
void on_MenuShowBroad_toggled(GtkCheckMenuItem *checkmenuitem, gpointer user_data)
{
	GtkWidget *pLyricWnd = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
	gtk_window_set_decorated(GTK_WINDOW(pLyricWnd), checkmenuitem->active);
	theApp.m_configs.bShowBroad = checkmenuitem->active;
	theApp.UpdataSetting();
}
void on_MenuMouseScroll_toggled(GtkCheckMenuItem *checkmenuitem, gpointer user_data)
{
	this.m_bScrollMouseChange = !this.m_bScrollMouseChange; 
}
void on_MenuConfig_activate(GtkWidget* wideget, gpointer user_data)
{
	gtk_widget_show(glade_xml_get_widget(theApp.m_xml, "ConfigDlg"));
}
gboolean on_ShowLyric_scroll_event(GtkWidget *widget, GdkEventScroll *event, gpointer user_data)
{
	if (event->type != GDK_SCROLL || !this.m_bScrollMouseChange)return FALSE;
	
	switch (event->direction)
	{
	case GDK_SCROLL_UP:
	case GDK_SCROLL_LEFT:
		ChangeLyricTime(1000);
		break;
	case GDK_SCROLL_DOWN:
	case GDK_SCROLL_RIGHT:
		ChangeLyricTime(-1000);
		break;
	}
	return FALSE;
}
gboolean on_ShowLyric_motion_notify_event(GtkWidget *widget, GdkEventMotion *event, gpointer user_data)
{
	return FALSE;
}

gboolean on_ShowLyric_button_press_event(GtkWidget *widget, GdkEventButton *event,
		gpointer user_data)
{
	if (event->button == 3)
	{
		GtkWidget *pLyricWnd = glade_xml_get_widget(theApp.m_xml, "ShowLyric");
		GtkWidget *window = glade_xml_get_widget(theApp.m_xml, "LyricMenu");
		GtkCheckMenuItem *pMenuMouseScroll = (GtkCheckMenuItem*)glade_xml_get_widget(theApp.m_xml, "MenuMouseScroll");;
		GtkCheckMenuItem *pMenuShowBroad = (GtkCheckMenuItem*)glade_xml_get_widget(theApp.m_xml, "MenuShowBroad");;
		pMenuMouseScroll->active = this.m_bScrollMouseChange;
		pMenuShowBroad->active = gtk_window_get_decorated(GTK_WINDOW(pLyricWnd));
		gtk_menu_popup(GTK_MENU(window), NULL, NULL, NULL, NULL, event->button,
				0);
		return TRUE;
	}
	return FALSE;
}

void on_ShowLyric_window_state_event(gpointer data)
{
	if (!data)
		return;
	GtkWidget *window=GTK_WIDGET(data);
	int istate = gdk_window_get_state(GDK_WINDOW(window->window));

	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(window), TRUE);
	gtk_window_set_skip_pager_hint(GTK_WINDOW(window), TRUE);
	switch (istate)
	{
	case GDK_WINDOW_STATE_ICONIFIED:
		gtk_window_set_skip_taskbar_hint(GTK_WINDOW(window), FALSE);
		gtk_window_set_skip_pager_hint(GTK_WINDOW(window), FALSE);
		//LyricDebug("GDK_WINDOW_STATE_ICONIFIED:the window is minimized.\n");
		break;
	case GDK_WINDOW_STATE_WITHDRAWN:
		//LyricDebug("GDK_WINDOW_STATE_WITHDRAWN:the window is not shown.\n");
		break;
	case GDK_WINDOW_STATE_MAXIMIZED:
		//LyricDebug("GDK_WINDOW_STATE_MAXIMIZED:the window is maximized.\n");
		break;
	case GDK_WINDOW_STATE_STICKY:
		//LyricDebug("GDK_WINDOW_STATE_STICKY:the window is sticky.\n");
		break;
	case GDK_WINDOW_STATE_FULLSCREEN:
		//LyricDebug("GDK_WINDOW_STATE_FULLSCREEN:the window is maximized without decorations.\n");
		break;
	case GDK_WINDOW_STATE_ABOVE:
		//LyricDebug("GDK_WINDOW_STATE_ABOVE:the window is kept above other windows. \n");
		break;
	case GDK_WINDOW_STATE_BELOW:
		//LyricDebug("GDK_WINDOW_STATE_BELOW:the window is kept below other windows. \n");
		break;
		/*
		 default:
		 //LyricDebug("unknow state(%d)\n", istate);
		 gtk_window_set_skip_taskbar_hint (GTK_WINDOW (window), FALSE);
		 gtk_window_set_skip_pager_hint (GTK_WINDOW (window), FALSE);
		 break;
		 */
	}
}

gboolean on_ShowLyric_delete_event(GtkWidget *widget, GdkEvent *event,
		gpointer user_data)
{
	// 将关闭事件改成最小化
	gtk_window_iconify(GTK_WINDOW(user_data));
	// 如果返回FALSE，GTK将发出"destroy"信号;
	// 如果返回TRUE， 则不让该窗口关闭
	return TRUE;
}
